package com.ibm.able.examples.ableagent;

//====================================================================
//
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// Product: com.ibm.able.examples.ableagent
//
// (C) Copyright IBM Corp. 2000 All Rights Reserved.
//
// US Government Users Restricted Rights - Use, duplication or
// disclosure restricted by GSA ADP Schedule Contract with 
// IBM Corp.
//
//                                                                        
//                             DISCLAIMER                                 
//                             ----------                                 
//                                                                        
// This material contains programming source code for your consideration. 
// These examples have not been thoroughly tested under all conditions.   
// IBM, therefore, cannot guarantee or imply reliability, serviceability, 
// performance or function of these programs.  All programs contained     
// herein are provided to you "AS IS".  THE IMPLIED WARRANTIES OF         
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY     
// DISCLAIMED.                                                            
//                                                                                                                                               
//====================================================================

//====================================================================
// Imports
//====================================================================
import java.beans.*;
import javax.swing.*;

import com.ibm.able.*;


/**
 * This class provides the bean info for the Simple Able Agent.
 *
 * @version  $Revision: 1.9 $, $Date: 2000/09/28 15:20:11 $
 *
 * @author   Joe Bigus
 */
public class SimpleAbleAgentBeanInfo extends SimpleBeanInfo {

  //==================================================================
  //
  // Class VariAbles
  //
  //==================================================================
  private final static Class customizerClass = com.ibm.able.examples.ableagent.SimpleAbleAgentCustomizer.class;
  static final long    serialVersionUID = 1999100100000000001L;

  Class beanClass = SimpleAbleAgent.class;
  String iconColor16x16Filename = "simpleagent16.gif";
  String iconColor32x32Filename = "simpleagent32.gif";
  String iconMono16x16Filename = null;
  String iconMono32x32Filename = null;


    //-----------------------------------------------------------------
    // Constructors
    //-----------------------------------------------------------------
    public SimpleAbleAgentBeanInfo() {
    }

  /**
   * Retrieve a descriptor for this bean.
   *
   * @return    A bean descriptor which specifies a customizer for this
   *            bean class.
   */
  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor returnDescriptor = new BeanDescriptor(beanClass, customizerClass);
    returnDescriptor.setValue("hidden-state", Boolean.TRUE);
    returnDescriptor.setValue("able-category",Able.CAT_SAMPLES) ; // icon palette page
    returnDescriptor.setValue("able-slot", "2") ; // horizontal position on canvas
    returnDescriptor.setValue("able-listInNewAgentMenu", Boolean.TRUE);
    return returnDescriptor;
  }



  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
    }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass); // AbleDefaultAgent info
      return new BeanInfo[] { superBeanInfo };
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
  /**
   * Determine the copyright of this class.
   *
   * @return    A String containing this class's copyright statement.
   *            <p>
   */
  public static String Copyright() {
    return Able.Copyright;
  }
}





