

package com.ibm.able.examples.genetic;

import com.ibm.able.beans.*;

/**
*   This class maximizes the number of on bits (1) in a binary string
*/
public class TstGeneticFunction1 extends AbleGeneticObject {

  static final long    serialVersionUID = 1999100100000000001L;
  static final String  Copyright = "(C) Copyright IBM Corporation, 1999. All rights reserved. ";

  public TstGeneticFunction1() {
    chromosomeLength = 20 ;
    vocabulary = "01" ;
    chromosomeType = String.class ;
  }

  public double getFitness() {

     return fitness ;

  }


  /**
  *  just add up the number of ones in the chromosome
  */
  public double computeFitness() {

    // this is deterministic, if already computed,
    // no sense if re-doing work
    if (fitnessComputed) return fitness ;

     int size = chromosomeLength ;
     double sum = 0.0;
     for (int i=0 ; i < size ; i++) {
        if (((String)chromosome).charAt(i) =='1') sum = sum + 1.0 ;
     }
     fitness = sum ;
     fitnessComputed = true; 

     return fitness ;
  }
}
