package com.ibm.able.examples.fuzzy;


import java.beans.*;
import com.ibm.able.*;


public class SampleSensorEffectorBeanInfo extends SimpleBeanInfo {

  static final long serialVersionUID = 1999100100000000001L;

  Class  beanClass = SampleSensorEffector.class;

  String iconColor16x16Filename = "seneff16.gif";
  String iconColor32x32Filename = "seneff32.gif";
  String iconMono16x16Filename;
  String iconMono32x32Filename;
  private final static Class customizerClass = com.ibm.able.examples.fuzzy.SampleSensorEffectorCustomizer.class;


  public SampleSensorEffectorBeanInfo() {
  }


  public BeanDescriptor getBeanDescriptor() {
    //BeanDescriptor returnDescriptor = new BeanDescriptor(beanClass);
    BeanDescriptor returnDescriptor = new BeanDescriptor(beanClass, customizerClass);
    returnDescriptor.setValue("hidden-state", Boolean.TRUE);
    returnDescriptor.setValue("able-category",Able.CAT_SAMPLES);
    returnDescriptor.setValue("able-slot", "2") ;
    return returnDescriptor;
  }


  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
      case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
      case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
      case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename  != null ? loadImage(iconMono16x16Filename)  : null;
      case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename  != null ? loadImage(iconMono32x32Filename)  : null;
    }
    return null;
  }


  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
  

  /**
   * Determine the copyright of this class.
   *
   * @return    A String containing this class's copyright statement.
   *            <p>
   */
  public static String Copyright() {
    return Able.Copyright;
  }

}
