package com.ibm.able.examples.fuzzy;


//====================================================================
// Imports
//====================================================================
import java.awt.*;
import java.rmi.*;
import javax.swing.*;

import com.ibm.able.*;


/**
 * This class provides the customizer for the fuzzy SampleSensorEffector.
 *
 * @version  $Revision: 1.2 $, $Date: 2000/09/12 14:16:36 $
 *
 */
public class SampleSensorEffectorCustomizer extends AbleObjectCustomizer {

  //-----------------------------------------------------------------
  // Member variables
  //-----------------------------------------------------------------


  //-----------------------------------------------------------------
  // Constructors
  //-----------------------------------------------------------------
  /**
   *  Construct a Self Organizing Map Customizer dialog.  Dialog is
   *  not modal so other windows can be active at the same time.
   *
   * @param frame the frame from which the dialog is displayed.
   * @param title the String to display in the dialog's title bar. 
   */
  public SampleSensorEffectorCustomizer(JFrame frame, String title) {
    super(frame, title, false);   // non-modal
    setCustomizer(this);          // so OK calls updateObject on this
  }


  /**
   *  Construct a Self Organizing Map Customizer Dialog.  Dialog is
   *  not modal so other windows can be active at the same time.
   *
   */
  public SampleSensorEffectorCustomizer() {
    this(new JFrame(), "Sample Fuzzy Sensor/Effector Customizer");
  }


  //--------------------------------------------------------------------
  // Methods inherited from Customizer interface
  //--------------------------------------------------------------------
  /**
   * Write the data from the object to the panel(s) provided
   * by this customizer. The panel saves a reference to the
   * bean being customized.
   * Pass the object and its data to any inherited panel.
   *
   * @param     theBean
   *            The bean that is to be changed.
   */
  public void setObject(Object theBean) {
    super.setObject(theBean);
  }


  /**
   * Update the bean that is being customized.  This method is 
   * called when the dialog's OK button is pressed.
   *
   * @exception RemoteException is thrown when the panel values
   *            cannot be set on the bean.
   */
  public void updateObject() throws RemoteException {
    super.updateObject();
  }

}
